### Persefone.jl - a model of agricultural landscapes and ecosystems in Europe.
###
### This file is responsible for managing the farm module(s).
###    

###XXXXXXX In future, I want to expand Persefone into a proper ABM with multiple farm actors.
###XXXXXXX However, at the moment, all fields are controlled centrally -> see farm/farm.jl

"""
    Farmer

This is the agent type for the farm ABM. (Not yet implemented.)
"""
mutable struct Farmer <: ModelAgent
    #XXX make this into an abstract type and create subtypes for different farm submodels? (#69)
    const id::Int64
    fields::Vector{Int64} # IDs of the farmplots this farmer owns
    totalincome::Float64
end

"""
    stepagent!(farmer, model)

Update a farmer by one day.
"""
function stepagent!(farmer::Farmer, model::SimulationModel)
    #TODO
    # - check each field, whether it can be harvested
    # - if so, harvest it and set its crop to "no growth"
    # - [later: calculate income based on yield and annual price]
    # - if a field has been harvested, check if the next crop can be sown
end

"""
    initfarms!(model)

Initialise the model with a set of farm agents.
"""
function initfarms!(model::SimulationModel)
    #TODO
end
